﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.GridView;
using Telerik.Windows.Controls.GridView.Cells;

namespace CellMouseTrigger
{
	/// <summary>
	/// Interaction logic for Window1.xaml
	/// </summary>
	public partial class Window1 : Window
	{
		public Window1()
		{
			InitializeComponent();

			RadGridView1.ItemsSource = new Message[] { 
				new Message { Sender = "tom@hanna-barbera.com", Subject = "Cats are cool", Size = 100 },
				new Message { Sender = "jerry@hanna-barbera.com", Subject = "Mice are cool", Size = 100 },
				new Message { Sender = "spike@hanna-barbera.com", Subject = "Dogs are cool", Size = 100 }
			};
		}

		private void gv1_PreviewValidate(object sender, RoutedEventArgs e)
		{
			CellValidatingRoutedEventArgs args = (CellValidatingRoutedEventArgs)e;

			GridViewCell cell = (GridViewCell)args.OriginalSource;

			bool isValid = true;
			if (args.NewValue is int)
			{
				int intValue = (int)args.NewValue;
				isValid = intValue >= 0 && intValue <= 100;
			}

			if (args.NewValue is string)
			{
				isValid = string.IsNullOrEmpty((string)args.NewValue);
			}

			ValidationHelper.SetIsValid(cell, isValid);

			args.ValidationResult = new Telerik.Windows.Controls.GridView.ValidationResult(isValid, null);
		}
	}
}